// ExportFuncExe.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <string>
#include <windows.h>

typedef void(*FuncPtrT)(const std::string& callFrom);

int _tmain(int argc, _TCHAR* argv[])
{
	HINSTANCE hDll = ::LoadLibrary("ImportingDLL.dll");
	if(!hDll)
	{
		std::cerr << "DLL not found" << std::endl;
	}
	else
	{
		FuncPtrT pFunc = (FuncPtrT)::GetProcAddress(hDll,"ExportFunctionFromDLL");
		if(pFunc)
		{
			(*pFunc)("EXE");
		}
		else
		{
			std::cerr << "Not found proper function" << std::endl;
		}
		::FreeLibrary(hDll);
	}

	return 0;
}

__declspec(dllexport) void ExportFunctionFromEXE(const std::string& callFrom)
{
	std::cout << "Exe export function called From " << callFrom << std::endl;
}