// ImportingDLL.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "ImportingDLL.h"
typedef void(*FuncPtrT)(const std::string& callFrom);

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}

// This is an example of an exported variable
IMPORTINGDLL_API int nImportingDLL=0;

// This is an example of an exported function.
IMPORTINGDLL_API int fnImportingDLL(void)
{
	return 42;
}

IMPORTINGDLL_API void ExportFunctionFromDLL(const std::string& callFrom) {
	std::cout << "DLL export function called From " << callFrom << std::endl;
	HINSTANCE hExe = GetModuleHandle(NULL); // ڷ NULL ѱ ȣ ش(⼭ DLL ȣ) μ ڵ ´.
	FuncPtrT pFunc = (FuncPtrT)::GetProcAddress(hExe, "ExportFunctionFromEXE");
	if(pFunc)
		(*pFunc)("DLL");
	else
		std::cerr << "Not found proper " << callFrom << " function" << std::endl;
}

// This is the constructor of a class that has been exported.
// see ImportingDLL.h for the class definition
CImportingDLL::CImportingDLL()
{ 
	return; 
}
